//
// Created by philipp on 16.05.18.
//

#include <iostream>
#include "../include/PC2CarLib/CommandSender.h"
#include "../include/PC2CarLib/CommandReceiver.h"

int main(int argc, char ** argv)
{
    using namespace pc2car;

    networking::Networking net;
    CommandSender sender{net, "127.0.0.1"};
    auto receiver = CommandReceiver::create(net);

    receiver->receiveCommands(
        [receiver](CommandCode code)
        {
            using namespace commandCodes;
            std::cout << "code: " << code << "\n";
            switch (code)
            {
                case ENABLE_LOGGING:
                    std::cout << "ENABLE_LOGGING\n";
                    std::cout << receiver->isLoggingEnabled().get() << "\n";
                    break;

                case ENABLE_PLATOON:
                    std::cout << "ENABLE_PLATOON\n";
                    std::cout << receiver->isPlatoonEnabled().get() << "\n";
                    break;

                case ENABLE_RC_MODE:
                    std::cout << "ENABLE_RC_MODE\n";
                    std::cout << receiver->isRcModeEnabled().get() << "\n";
                    break;

                case SET_PS:
                    std::cout << "SET_PS\n";
                    std::cout << receiver->getPlatoonSpeed().get() << "\n";
                    break;

                case SET_IPD:
                    std::cout << "SET_IPD\n";
                    std::cout << receiver->getInnerPlatoonDistance().get() << "\n";
                    break;

                case SET_SPEED:
                    std::cout << "SET_SPEED\n";
                    std::cout << receiver->getSpeed().get() << "\n";
                    break;
            }
            std::cout << std::flush;
        });

    while (1);
    return 0;
}